/*
 *  The Mana World
 *  Copyright (C) 2004  The Mana World Development Team
 *  Copyright (C) 2009-2010  Andrei Karas
 *
 *  This file is part of The Mana World.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "chatlog.h"

#include <iostream>
#include <sstream>
#include <dirent.h>

#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>

#ifdef WIN32
#include <windows.h>
#elif defined __APPLE__
#include <Carbon/Carbon.h>
#endif

#include "log.h"
#include "configuration.h"

#include "utils/stringutils.h"

ChatLogger::ChatLogger()
{
}

ChatLogger::~ChatLogger()
{
    if (mLogFile.is_open())
    {
        mLogFile.close();
    }
}

void ChatLogger::setLogFile(const std::string &logFilename)
{
    if (mLogFile.is_open())
    {
        mLogFile.close();
    }

    mLogFile.open(logFilename.c_str(), std::ios_base::app);

    if (!mLogFile.is_open())
    {
        std::cout << "Warning: error while opening " << logFilename <<
            " for writing.\n";
    }
}

void ChatLogger::setLogDir(const std::string &logDir)
{
    mLogDir = logDir;

    if (mLogFile.is_open())
    {
        mLogFile.close();
    }

    DIR *dir = opendir(mLogDir.c_str());
    if (dir == NULL)
        makeDir(mLogDir);
    else
        closedir(dir);
}

void ChatLogger::log(std::string str)
{
    std::string dateStr = getDateString();
    if (!mLogFile.is_open() || dateStr != mLogDate)
    {
        mLogDate = dateStr;
        setLogFile(mLogDir + "/" + mServerName + "/#General_" + dateStr + ".log");
    }

    str = removeColors(str);
    writeTo(mLogFile, str);
}

void ChatLogger::log(std::string name, std::string str)
{
    std::ofstream logFile;
    logFile.open((mLogDir + "/" + mServerName + "/" + secureName(name)
                 + "_" + getDateString() + ".log").c_str(),
                 std::ios_base::app);

    if (!logFile.is_open())
    {
        return;
    }

    str = removeColors(str);
    writeTo(logFile, str);

    if (logFile.is_open())
    {
        logFile.close();
    }

}

std::string ChatLogger::getDateString() const
{
    std::string date;

    time_t rawtime;
    struct tm *timeinfo;
    char buffer [80];

    time (&rawtime);
    timeinfo = localtime(&rawtime);

    strftime(buffer, 79, "%y-%m-%d", timeinfo);
    date = buffer;
    return date;
}

std::string ChatLogger::secureName(std::string &str) const
{
    std::string name(str);
    for (unsigned int f = 0; f < str.length(); f ++)
    {
        if (name[f] < '0' && name[f] > '9' && name[f] < 'a' && name[f] > 'z'
            && name[f] < 'A' && name[f] > 'Z'
            && name[f] != '-' && name[f] != '+' && name[f] != '='
            && name[f] != '.' && name[f] != ','&& name[f] != ')'
            && name[f] != '(' && name[f] != '[' && name[f] != ')')
        {
            name[f] = '_';
        }
    }
    return name;
}

void ChatLogger::writeTo(std::ofstream &file, std::string &str) const
{
    file << str << std::endl;
}

void ChatLogger::setServerName(std::string serverName)
{
    if (serverName == "")
    {
        serverName = config.getValue("MostUsedServerName0", "server.themanaworld.org");
    }

    logger->log("server name:" + serverName);

    if (mLogFile.is_open())
    {
        mLogFile.close();
    }

    mServerName = secureName(serverName);
    if (mLogDir != "")
    {
        DIR *dir = opendir((mLogDir + "/" + mServerName).c_str());
        if (dir == NULL)
            makeDir(mLogDir + "/" + mServerName);
        else
            closedir(dir);
    }
}

void ChatLogger::makeDir(std::string dir)
{
#ifdef WIN32
    mkdir(dir.c_str());
#else
    mkdir(dir.c_str(), 0770);
#endif
}
